#!/system/bin/sh
# Please don't hardcode /magisk/modname/... ; instead, please use $MODDIR/...
# This will make your scripts compatible even if Magisk change its mount point in the future
MODDIR=${0%/*}

# This script will be executed in post-fs-data mode
# More info in the main Magisk thread

#FSTRIM
fstrim -v /system
fstrim -v /vendor
fstrim -v /data
fstrim -v /cache
fstrim -v /system
fstrim -v /vendor
fstrim -v /metadata
fstrim -v /odm
fstrim -v /system_ext
fstrim -v  /product
fstrim -v /data
fstrim -v /cache

#Suka
local installed=$(pm list package | cut -d ":" -f 2 | grep com.mobile.legends)
    if [ ! -z $installed ]; then
        local playerprefs=/data/data/com.mobile.legends/shared_prefs/com.mobile.legends.v2.playerprefs.xml
        if grep -q "HighFpsModeSee" $playerprefs; then
            sed -i 's/"HighFpsModeSee" value="[2-4]"/"HighFpsModeSee" value="4"/' $playerprefs
        else
            local fpsmode='<int name="HighFpsModeSee" value="4" />'
            sed -i "3i$fpsmode" $playerprefs
        fi
        if grep -q "PerformanceDevice_BestQuality" $playerprefs; then
            sed -i 's/"PerformanceDevice_BestQuality" value="[1-4]"/"PerformanceDevice_BestQuality" value="4"/' $playerprefs
        else
            local quality='<int name="PerformanceDevice_BestQuality" value="4" />'
            sed -i "3i$quality" $playerprefs
        fi
        if grep -q "PreformanceLv" $playerprefs; then
            sed -i 's/"PreformanceLv" value="[1-4]"/"PreformanceLv" value="4"/' $playerprefs
        else
            local level='<int name="PreformanceLv" value="4" />'
            sed -i "3i$level" $playerprefs


write /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor performance
write /sys/devices/system/cpu/cpufreq/performance/go_hispeed_load 75
write /sys/devices/system/cpu/cpufreq/performance/above_hispeed_delay 0
write /sys/devices/system/cpu/cpufreq/performance/boost 1
write /sys/devices/system/cpu/cpufreq/performance/max_freq_hysteresis 1
write /sys/devices/system/cpu/cpufreq/performance/align_windows 1
write /sys/devices/soc/1c00000.qcom,kgsl-3d0/devfreq/1c00000.qcom,kgsl-3d0/governor performance
write /sys/class/kgsl/kgsl-3d0/devfreq/governor msm-adreno-tz
write /sys/module/adreno_idler/parameters/adreno_idler_active 0
write /sys/module/lazyplug/parameters/nr_possible_cores 8
write /dev/cpuset/foreground/cpus 0-3,4-7
write /dev/cpuset/foreground/boost/cpus 4-7
write /dev/cpuset/top-app/cpus 0-7


# This script will be executed in post-fs-data mode
setenforce 0
echo alweys_support >/sys/devices/system/cpu/cpufreq/policy4/scaling_setspeed;
echo alweys_support >/sys/devices/system/cpu/cpufreq/policy6/scaling_setspeed;
echo '1' > /sys/devices/system/cpu/sched/cpu_prefer;
echo boost > /sys/devices/system/cpu/sched/sched_boost;
echo '1' > /sys/devices/system/cpu/eas/enable;
echo 'boost' > /sys/devices/system/cpu/sched/sched_boost;
echo '3' > /proc/cpufreq/cpufreq_power_mode;
echo '1' > /proc/cpufreq/cpufreq_imax_enable;
echo '0' > /proc/cpufreq/cpufreq_imax_thermal_protect;
echo '1' > /sys/devices/system/cpu/perf/enable;
chmod '0644' > /sys/devices/system/cpu/perf/enable;
sleep 0.2
echo '35' > /dev/stune/foreground/schedtune.boost;
chmod '0444' /dev/stune/foreground/schedtune.boost;
echo '1' > /proc/cpufreq/cpufreq_cci_mode;
chmod '0444' /proc/cpufreq/cpufreq_cci_mode;
echo 4096M >/sys/block/zram0/disksize
mkswap /data/zram0
swapon  /data/zram0

# VM settings to improve overall user experience and performance.
for vm in /proc/sys/vm/
do
if [[ -d "/proc/sys/vm" ]]
then
write "${vm}drop_caches" "6"
write "${vm}dirty_background_ratio" "100"
write "${vm}dirty_ratio" "100"
write "${vm}dirty_expire_centisecs" "6000"
write "${vm}dirty_writeback_centisecs" "6000"
write "${vm}page-cluster" "0"
write "${vm}stat_interval" "10"
write "${vm}swappiness" "200"
write "${vm}swap_ratio_enable" "1"
write "${vm}swap_ratio" "200"
write "${vm}vfs_cache_pressure" "200"

#More
function run() {

resetprop -n persist.sys.dalvik.hyperthreading true
resetprop -n persist.sys.dalvik.multithread true

resetprop -n debug.sf.showupdates 0 
resetprop -n debug.sf.showcpu 0 
resetprop -n debug.sf.showbackground 0 
resetprop -n debug.sf.showfps 0

resetprop -n debug.sf.hw 1

resetprop -n ro.hwui.texture_cache_size 72
resetprop -n ro.hwui.layer_cache_size 48
resetprop -n ro.hwui.r_buffer_cache_size 8
resetprop -n ro.hwui.path_cache_size 32
resetprop -n ro.hwui.gradient_cache_size 1
resetprop -n ro.hwui.drop_shadow_cache_size 6
resetprop -n ro.hwui.texture_cache_flushrate 0.4
resetprop -n ro.hwui.text_small_cache_width 1024
resetprop -n ro.hwui.text_small_cache_height 1024
resetprop -n ro.hwui.text_large_cache_width 2048
resetprop -n ro.hwui.text_large_cache_height 2048

resetprop -n ro.iorapd.enable false
resetprop -n iorapd.perfetto.enable false
resetprop -n iorapd.readahead.enable false
resetprop -n persist.device_config.runtime_native_boot.iorap_readahead_enable false

}

run > /dev/null 2>&1